"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@reactive-js/react");
const observable_1 = require("@reactive-js/observable");
const pipe_1 = require("@reactive-js/pipe");
const react_2 = require("react");
const empty = {
    path: "",
    query: "",
    fragment: "",
};
exports.Router = function Router(props) {
    const { locationStore, notFound, routes, scheduler } = props;
    const observable = react_2.useMemo(() => {
        const routeMap = {};
        for (const [path, component] of routes) {
            routeMap[path] = component;
        }
        const uriUpdater = (updater) => {
            locationStore.dispatch(updater);
        };
        const pairify = ([_, oldState], next) => oldState === empty ? [undefined, next] : [oldState, next];
        return pipe_1.pipe(locationStore, observable_1.scan(pairify, () => [
            undefined,
            empty,
        ]), observable_1.map(([referer, uri]) => react_2.createElement(routeMap[uri.path] || notFound, {
            referer,
            uri,
            uriUpdater,
        })));
    }, [locationStore, notFound, routes]);
    const element = react_1.useObservable(observable, scheduler);
    return (element !== null && element !== void 0 ? element : null);
};
//# sourceMappingURL=router.js.map